#define internal	/* Define internal or external shunt control */

#define solartemp 3
#define tanktoptemp 0
#define tankmiddletemp 1
#define tankbottomtemp 2
#define shunt 4
#define forwardtemp 4
#define outsidetemp 5
#define insidetemp 6
#define returntemp 7

#define close 0
#define open 1

#define sopenout 2
#define scloseout 3
#define solarpumpout 4
#define heatpumpout 5
#define mainpumpout 0
#define electricout 1


#define solar 1
#define heatpump 2
#define mainpump 3

#define on 1
#define off 0

#define dout_port PORTC
#define dout_ddr DDRC
#define dout_pin PINC
#define din_port PORTB
#define din_ddr DDRB
#define din_pin PINB

unsigned char mcaltimer = 0;
unsigned char shunttime = 0;
unsigned char solarpumpstate = 0;
unsigned char heatpumpstate = 0;
unsigned char mainpumpstate = 0;
unsigned char electricstate = 0;

unsigned char shunttimer = 0;
unsigned char regtimer = 0;
unsigned char sdir = close;


void setup(void);				/* Setup of ports, ADC, etc */
unsigned int adcread(unsigned char chan);	/* Makes read from ADC */
double gettemp(unsigned char chan);		/* Calculates temp from TMP36 sensor on ADC */
void setpumpstates(void);			/* Logic routine for pump states */
void LCD_drawschema(void);			/* Draws system schematic for display */
void showpumps(void);				/* Updates pump states for display */
void showtemps(void);				/* Updates temperatures for display */
unsigned char getshuntpos(void);		/* Calculates main shunt position */
int main(void);					/* Main routine */


