/* How do you control a dog? Use a leash!	*/
/* This is a library for controlling		*/
/* Electronic Assembly's DOG series			*/
/* graphic LCD displays.					*/	
/* At the moment limited to DOGS			*/

#include "leash.h"
#include "lcdfont.h"


void SPI_init(void){
	


	SPI_DDR |= (1 << DO) | (1 << CLK) | ~(1 << DI);		
	RST_DDR |= (1 << RST_PIN);
	CS_DDR |= (1 << CS_PIN);
	CD_DDR |= (1 << CD_PIN);
	SPI_SETCLK;		







/*
SPI_DDR |= (1 << DO) | (1 << CLK) | ~(1 << DI);		
RST_DDR |= (1 << RST_PIN);
CS_DDR |= (1 << CS_PIN);
CD_DDR |= (1 << CD_PIN);
SPCR = 1<<SPE | 1<<MSTR | 1<<CPOL | 1<<CPHA | 1<<SPR0;
*/


}


void SPI_send(char data){			
  

 	unsigned char i = 0;
	for(i=0;i<8;i++){
		if(data & 0b10000000){
		SPI_SETDO;
		}	
		else SPI_CLEARDO;

	SPI_CLEARCLK;					
	SPI_SETCLK;						
	data = data << 1;
	}







/*
	SPDR = data;
	while ( !(SPSR & 0x80) );
*/
}


void LCD_writecmd(char cmd){		
	LCD_CLEARDATA;
	LCD_SELECT;
	SPI_send(cmd);
	LCD_DESELECT;
}


void LCD_writedata(char data){		
	LCD_SETDATA;
	LCD_SELECT;
	SPI_send(data);
	LCD_DESELECT;
	LCD_CLEARDATA;
}


void LCD_setxy(char x, char y){		
	char xlow = (x & 0b00001111);
	x = (x >> 4);
	char xhigh = (x & 0b00001111);
	
	LCD_writecmd(xlow | 0b00000000);
	LCD_writecmd(xhigh | 0b00010000);
	LCD_writecmd(y | 0b10110000); // for DOGS
//	LCD_writecmd(y | 0b01100000); // for DOGXL
}


void FB_setxy(char x, char y){		
	FB_xpos = x;
	FB_ypos = y;
}


void LCD_clear(void){					
	unsigned char x = 0;
	unsigned char y = 0;	
	for(y = 0; y < LCD_Y/8; y++){
		LCD_setxy(0,y);
		for(x = 0; x < LCD_X; x++){
		LCD_writedata(0x00);
		}
	}
}


void FB_clear(void){					
	unsigned char x = 0;
	unsigned char y = 0;	
	for(y = 0; y < LCD_Y/8; y++){
		FB_setxy(0,y);
		for(x = 0; x < LCD_X; x++){
		FB_writedata(0x00);
		}
	}
}


void LCD_update(void){					
	unsigned char y = 0;
	unsigned char x = 0;
	for(y = 0; y < LCD_Y/8; y++){
		LCD_setxy(0,y);
		for(x = 0; x < LCD_X; x++){
		LCD_writedata(fb[x][y]);
		}

	}
}


void FB_writechar(unsigned char x, unsigned char y, char ch)
{   
   char ch_data[5] = {0, 0, 0, 0, 0};
   if(ch != ' ') FB_clearrect(x,y,x+5,y+7);
   if (ch == ' '){
      FB_xpos += 4;
	  FB_clearrect(x,y,x+4,y+7);
      FB_setxy(x+4,y);
      return; 
   }
   if(ch == '1'){
	  x += 1;
   }
   if(ch == 'I'){
  	  x += 1;
   }
   if(ch == 'i'){
      x += 1;
   }



	ch_data[0] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 0]));
	ch_data[1] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 1]));
	ch_data[2] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 2]));
	ch_data[3] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 3]));
	ch_data[4] = pgm_read_byte(&(smallFont[(ch - 32) * 5 + 4]));
   //if (ch_data[0] != 0)
   //{
      for(unsigned char a = 0; a < sizeof(ch_data); a++)
      {
         for(unsigned char i = 8; i > 0; i--)
         {
            if ((ch_data[a] == 0) || ((x + a) == 127))
              break;
               
            if (ch_data[a] & 0x80)
               FB_drawdot((x + a), (y + i));
               
            ch_data[a] <<= 1;
         }
      }
   //}
}

void FB_writestring(unsigned char x, unsigned char y, char *s)
{
   unsigned char i = 0;
   
   while(s[i])
   {
      FB_writechar(x, y, s[i]);
      x = (FB_xpos + 1);
      
      if (FB_xpos == LCD_X)
      {
         return;
      }
      
      i++;
   }
}


/* 
void FB_writechar(char data){

	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 0])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 1])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 2])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 3])));
	FB_writedata(pgm_read_byte(&(smallFont[(data - 32) * 5 + 4])));
	FB_writedata(0x00);
}
*/

void FB_writedata(char data){		
	fb[FB_xpos][FB_ypos] = data;
	FB_xpos++;
}

/*
void FB_writestring(char *s)
{
	unsigned char i = 0;
	while(s[i]){
	FB_writechar(s[i]);
	i++;
	}


}
*/
void FB_drawpat(char pat, char count){
	unsigned char i = 0;
	for(i = 0; i < count; i++){
		FB_writedata(pat);
	}
}

void FB_clearrect(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2)
{
   for(int y = y1; y <= y2; y++)
   {
      for (int x = x1; x <= x2; x++)
      {
      FB_cleardot(x,y);   
      }
   }
}


void LCD_init(void){
	CS_DDR |= (1 << CS_PIN);
	CD_DDR |= (1 << CD_PIN);
	RST_DDR |= (1 << RST_PIN);
	RST_PORT |= (1 << RST_PIN);
	_delay_ms(1000);
	RST_PORT &= ~(1 << RST_PIN);
	_delay_ms(1000);
	RST_PORT |= (1 << RST_PIN);
	
//	LCD_writecmd(0b11110001);
//	LCD_writecmd(0b01100111); /* Set last COM electrode to 103 */
//	LCD_writecmd(0b11000000); /* SEG and COM normal */
//	LCD_writecmd(0b01000000);
//	LCD_writecmd(0b01010000); /* Start line at 0 */
//	LCD_writecmd(0b00101011); /* Panel loading at 28..38nF */
//	LCD_writecmd(0b11101011); /* 1/12 bias */
//	LCD_writecmd(0b10000001); 
//	LCD_writecmd(0b01011111); /* Set contrast */
//	LCD_writecmd(0b10001001); /* Set auto increment */
//	LCD_writecmd(0b10101111); /* Display ON */ 
//	LCD_writecmd(0b10100100);
/* Above is for DOGXL display */

#ifdef DOGS
	LCD_writecmd(0b01000000); /* Set start line 0 */
	LCD_writecmd(0b10100001); /* SEG reverse */
	LCD_writecmd(0b11000000); /* COM normal */
	LCD_writecmd(0b10100100); /* Pixels ON? */
	LCD_writecmd(0b10100110); /* INV off */
	LCD_writecmd(0b10100010); /* 1/9 bias */
	LCD_writecmd(0b00101111); /* Booster, regulator, follower ON */
	LCD_writecmd(0b00100111); /* Contrast */
	LCD_writecmd(0b10000001); /* Contrast */
	LCD_writecmd(0b00000110); /* Contrast */
	LCD_writecmd(0b11111010); /* Temp compensation */
	LCD_writecmd(0b10010000); /* Temp compensation */
	LCD_writecmd(0b10101111); /* Display ON */
/* Above is for DOGS display */
#endif

#ifdef DOGL
	LCD_writecmd(0b01000000); /* Set start line 0 */
	LCD_writecmd(0b10100001); /* SEG reverse */
	LCD_writecmd(0b11000000); /* COM normal */
	LCD_writecmd(0b10100110); /* INV off */
	LCD_writecmd(0b10100010); /* 1/9 bias */
	LCD_writecmd(0b00101111); /* Booster, regulator, follower ON */
	LCD_writecmd(0b11111000); /* Set internal booster to 4x */
	LCD_writecmd(0b00000000); /* Set internal booster to 4x */
	LCD_writecmd(0b00100111); /* Contrast */
	LCD_writecmd(0b10000001); /* Contrast */
	LCD_writecmd(0b00010000); /* Contrast */
	LCD_writecmd(0b10101100); /* No indicator */
	LCD_writecmd(0b00000000); /* No indicator */
	LCD_writecmd(0b10101111); /* Display ON */
/* Above is for DOGL display */
#endif

	LCD_clear();
	

}


unsigned char FB_readdata(void)	
{
   unsigned char data = fb[FB_xpos][FB_ypos];   
   
   return data;
}


void FB_drawdot(unsigned char x, unsigned char y)	
{
   FB_setxy(x, y/8);
   unsigned char tempdata = FB_readdata();
   tempdata = FB_readdata();
   FB_setxy(x, y/8);
   FB_writedata(tempdata | (1<<(y % 8)));
}


void FB_cleardot(unsigned char x, unsigned char y)	
{
   FB_setxy(x, y/8);
   unsigned char tempdata = FB_readdata();
   tempdata = FB_readdata();
   FB_setxy(x, y/8);
   FB_writedata(tempdata & ~(1<<(y % 8)));

}


void FB_drawline(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char clr)
{
   char deltax = abs(x2 - x1);
   char deltay = abs(y2 - y1);
   char x = x1;
   char y = y1;
   char xinc1;
   char xinc2;
   char yinc1;
   char yinc2;
   char den;
   char num;
   char numadd;
   char numpixels;

   if (x2 >= x1)
   {
      xinc1 = 1;
      xinc2 = 1;
   }
   
   else
   {
      xinc1 = -1;
      xinc2 = -1;
   }

   if (y2 >= y1)
   {
      yinc1 = 1;
      yinc2 = 1;
   }
   
   else
   {
      yinc1 = -1;
      yinc2 = -1;
   }

   if (deltax >= deltay)
   {
      xinc1 = 0;
      yinc2 = 0;
      den = deltax;
      num = deltax / 2;
      numadd = deltay;
      numpixels = deltax;
   }
   
   else
   {
      xinc2 = 0;
      yinc1 = 0;
      den = deltay;
      num = deltay / 2;
      numadd = deltax;
      numpixels = deltay;
   }

   for (unsigned char curpixel = 0; curpixel <= numpixels; curpixel++)
   {
      if (clr)
      {
         FB_cleardot(x, y);
      }
      
      else
      {
         FB_drawdot(x, y);
      }
      
      num += numadd;
      
      if (num >= den)
      {
         num -= den;
         x += xinc1;
         y += yinc1;
      }
      
      x += xinc2;
      y += yinc2;
   }
}


void FB_drawrect(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, unsigned char fill, unsigned char clr)
{
   if (fill != 0)
   {
      for (int i = y1; i <= y2; i++)
      {
         FB_drawline(x1, i, x2, i, clr);
      }
   }
   
   else
   {
      FB_drawline(x1, y1, x2, y1, clr);
      FB_drawline(x1, y2, x2, y2, clr);
      FB_drawline(x2, y1, x2, y2, clr);
      FB_drawline(x1, y1, x1, y2, clr);
   }
}


void FB_drawcircle(unsigned char x1, unsigned char y1, unsigned char radius)
{
   int f = 1 - radius;
   int ddF_x = 0;
   int ddF_y = -2 * radius;
   int x = 0;
   int y = radius;

   FB_drawdot(x1, y1 + radius);
   FB_drawdot(x1, y1 - radius);
   FB_drawdot(x1 + radius, y1);
   FB_drawdot(x1 - radius, y1);

   while(x < y)
   {
      if(f >= 0)
      {
         y--;
         ddF_y += 2;
         f += ddF_y;
      }
      
      x++;
      ddF_x += 2;
      f += ddF_x + 1;   
      FB_drawdot(x1 + x, y1 + y);
      FB_drawdot(x1 - x, y1 + y);
      FB_drawdot(x1 + x, y1 - y);
      FB_drawdot(x1 - x, y1 - y);
      FB_drawdot(x1 + y, y1 + x);
      FB_drawdot(x1 - y, y1 + x);
      FB_drawdot(x1 + y, y1 - x);
      FB_drawdot(x1 - y, y1 - x);
   }
}


