#define uninited 0	/* display mode */
#define startup 1	/* display mode */
#define normal 2	/* display mode */
#define menu 3		/* display mode */
#define editvar 4	/* display mode */
#define editcurve 5	/* display mode */
#define escape 66	/* button constant, arbitrary value */
#define enter 67	/* button constant, arbitrary value */
#define up 68		/* button constant, arbitrary value */
#define down 69		/* button constant, arbitrary value */
#define bktreg OCR0	/* PWM register for backlight */



#define menuamount 100
#define captionlength 20

#define escape_vect PCINT1_vect	/* interrupt vector for button escape */
#define up_vect INT0_vect		/* interrupt vector for button up */
#define down_vect INT1_vect		/* interrupt vector for button down */

#define enter_pin (PINB & 0b00000010)
#define escape_pin (PINB & 0b00000100)
#define up_pin (PINB & 0b00000001)
#define down_pin (PINB & 0b00001000)


#define stringfunc FB_writestring	/* Define your own function accepting (x,y,string) */
#define clearfunc FB_clear		/* Your own func to clear display or framebuffer */
#define eewritebyte eeprom_write_byte	/* Your own func for writing a byte to eeprom */
#define eereadbyte eeprom_read_byte	/* Your own func for reading a byte from eeprom */

unsigned char menuselect = 0;	/* global variable for menu selection */
unsigned char dispmode = normal;/* global variable for LCD mode, can be menu, normal, uninited, startup*/
unsigned int menulevel = 0;	/* global variable for menu item selection */


void keymanager(unsigned char key);
void menurender(void);

char maincaption[] = {"Main menu"};
char menucaptions[menuamount][captionlength] = {
{""}		/* Level 0 */
,{"HP parameters"}	/* Level 1 */
,{"Electric parameters"}/* Level 2 */
,{"Solar parameters"}	/* Level 3 */							
,{"Local sensors"}	/* Level 4 */
,{"Remote sensors"}	/* Level 5 */
,{"Display setup"}	/* Level 6 */
,{"Curve setup"}	/* Level 7 */	
,{"Shunt motor setup"}	/* Level 8 */
,{"Sensor calibration"}	/* Level 9 */
,{"HP on at shunt"}	/* Level 10 */
,{"HP off at shunt"}	/* Level 11 */	
,{"HP off with solar"}	/* Level 12 */
,{"HP max start tank T"}/* Level 13 */
,{"HP off at tank temp"}/* Level 14 */
,{"Block HP at indoor T"}/* Level 15 */	
,{""}			/* Level 16 */
,{""}			/* Level 17 */
,{""}			/* Level 18 */
,{""}			/* Level 19 */					
,{"El start at shunt"}	/* Level 20 */
,{"El stop at shunt"}	/* Level 21 */
,{"Block el at indoor>"}/* Level 22 */	
,{"El differential"}	/* Level 23 */
,{""}			/* Level 24 */
,{""}			/* Level 25 */
,{""}			/* Level 26 */	
,{""}			/* Level 27 */
,{"Stop main pump at"}	/* Level 28 */
,{"Start main pump at"}	/* Level 29 */
,{"Solar start at T+"}	/* Level 30 */	
,{"Solar stop at T+"}	/* Level 31 */
,{""}			/* Level 32 */
,{""}			/* Level 33 */
,{""}			/* Level 34 */					
,{""}			/* Level 35 */
,{""}			/* Level 36 */
,{""}			/* Level 37 */	
,{""}			/* Level 38 */
,{""}			/* Level 39 */
,{"S0 as"}		/* Level 40 */
,{"S1 as"}		/* Level 41 */	
,{"S2 as"}		/* Level 42 */
,{"S3 as"}		/* Level 43 */
,{"S4 as"}		/* Level 44 */
,{"S5 as"}		/* Level 45 */	
,{"S6 as"}		/* Level 46 */
,{"S7 as"}		/* Level 47 */
,{"S8 as"}		/* Level 48 */
,{"S9 as"}		/* Level 49 */
,{"R0 as"}		/* Level 50 */					
,{"R1 as"}		/* Level 51 */
,{"R2 as"}		/* Level 52 */	
,{"R3 as"}		/* Level 53 */
,{"R4 as"}		/* Level 54 */
,{"R5 as"}		/* Level 55 */
,{"R6 as"}		/* Level 56 */	
,{"R7 as"}		/* Level 57 */
,{"R8 as"}		/* Level 58 */
,{"R9 as"}		/* Level 59 */
,{"Contrast"}		/* Level 60 */					
,{"Backlght brightness"}/* Level 61 */
,{"IP address"}		/* Level 62 */	
,{"Netmask"}		/* Level 63 */
,{"Gateway"}		/* Level 64 */
,{""}			/* Level 65 */
,{""}			/* Level 66 */	
,{""}			/* Level 67 */
,{""}			/* Level 68 */
,{""}			/* Level 69 */
,{"20"}			/* Level 70 */
,{"15"}			/* Level 71 */					
,{"10"}			/* Level 72 */
,{"5"}			/* Level 73 */	
,{"0"}			/* Level 74 */
,{"-5"}			/* Level 75 */
,{"-10"}		/* Level 76 */
,{"-15"}		/* Level 77 */	
,{"-20"}		/* Level 78 */
,{"-25"}		/* Level 79 */
,{"Motor step time"}	/* Level 80 */
,{"Motor run time"}	/* Level 81 */					
,{""}			/* Level 82 */
,{"Reg. interval"}	/* Level 83 */	
,{"Deadband"}		/* Level 84 */
,{""}			/* Level 85 */
,{""}			/* Level 86 */
,{""}			/* Level 87 */	
,{""}			/* Level 88 */
,{""}			/* Level 89 */
,{"Tank upper sensor"}	/* Level 90 */
,{"Tank middle sensor"}	/* Level 91 */					
,{"Tank lower sensor"}	/* Level 92 */
,{"Solar sensor"}	/* Level 93 */	
,{"Shunt or fwd sensor"}/* Level 94 */
,{"Outdoor sensor"}	/* Level 95 */
,{"Indoor sensor"}	/* Level 96 */
,{"Return water sensor"}/* Level 97 */	
,{""}			/* Level 98 */
,{""}			/* Level 99 */
};

signed char vars[100];

